from rocolib.api.ports import Port
from rocolib.utils.utils import prefix as prefixString

class FacePort(Port):
  def __init__(self, parent, graph, face):
    Port.__init__(self, parent, {})
    self.graph = graph
    self.face = face

  def prefix(self, prefix=""):
    self.face = prefixString(prefix, self.face)

  def getFace(self):
    return self.graph.getFace(self.face)

  def getFaceName(self):
    return self.face

  def toString(self):
    return str(self.face.name)

  def canMate(self, otherPort):
    try:
      if (otherPort.getDecoration() is not None):
        return True
    except AttributeError:
      pass
    try:
      if (otherPort.getFaceName() is not None):
        return True
    except:
      pass
