from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatBase", inherit=True, prefix=None)
c.inheritAllInterfaces("boat")

c.addParameter("length", 169, paramType="length")
c.addParameter("width", 90, paramType="length")
c.addParameter("depth", 70, paramType="length")

c.addSubcomponent("boat", "BoatBase", inherit=True)

c.addConstraint(("boat", "boat.length"), "length")
c.addConstraint(("boat", "boat.width"), "width")
c.addConstraint(("boat", "boat.depth"), "depth")

c.addSubcomponent("servostackbattery", "ServoStackBatteryMount")
c.inheritAllInterfaces("servostackbattery")

c.addSubcomponent("portsplit", "SplitEdge")
c.inheritAllInterfaces("portsplit")
c.addConstConstraint(("portsplit", "toplength"), (169,))
c.addConstConstraint(("portsplit", "botlength"), (61, 108))

c.addSubcomponent("starsplit", "SplitEdge")
c.inheritAllInterfaces("starsplit")
c.addConstConstraint(("starsplit", "toplength"), (169,))
c.addConstConstraint(("starsplit", "botlength"), (108, 61))

c.addConnection(("portsplit", "topedge0"), ("boat", "portedge")) #both face the same direction
c.addConnection(("portsplit", "botedge1"), ("servostackbattery", "lservostackbatterysplit"))

c.addConnection(("starsplit", "topedge0"), ("boat", "staredge")) #both face the same direction
c.addConnection(("starsplit", "botedge0"), ("servostackbattery", "rservostackbatterysplit"))
#
# c.addConnection(("boat", "portedge"), ("servostackbattery", "lservostackbatterysplit")) #both face the same direction
# c.addConnection(("boat", "staredge"), ("servostackbattery", "lservostackbatterysplit"))

c.toLibrary("BoatWithServoStackBattery")
