from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

#A 5-sided rectangular beam enclosure

c = Component()

c.addParameter("numBatteries", 3, paramType="count", minValue=1, maxValue=10)

c.addParameter("batterylength", 60, paramType="length")
c.addParameter("batterywidth", 17, paramType="length")
c.addParameter("batterydepth", 9, paramType="length")

c.addSubcomponent("holder", "SimpleRectBeam", inherit=True, prefix=None)
c.addConstraint(("holder", "length"), "batterylength")
c.addConstraint(("holder", "width"), ("numBatteries", "batterydepth"), "x[0] * x[1]")
c.addConstraint(("holder", "depth"), "batterywidth")

c.addSubcomponent("bottom", "Rectangle", inherit=True)
c.addConstraint(("bottom", "l"), ("numBatteries", "batterydepth"), "x[0] * x[1]")
c.addConstraint(("bottom", "w"), "batterywidth")

c.addConnection(("bottom", "t"), ("holder", "botedge0"), angle=90)
c.addConnection(("bottom", "l"), ("holder", "botedge1"), tabWidth=5, angle=90)
c.addConnection(("bottom", "r"), ("holder", "botedge3"),tabWidth=5, angle=90)
c.addConnection(("bottom", "b"), ("holder", "botedge2"), tabWidth=5, angle=90)

c.toLibrary("BatteryHolder")
