from rocolib.api.components.Component import Component
from rocolib.api.ports.EdgePort import EdgePort
from rocolib.utils.dimensions import getDim
from rocolib.api.Function import Function


class ServoMount(Component):
  def modifyParameters(self):
    if self.getParameter("offset"):
        return

    servo = self.getParameter("servo")

    l = self.getParameter("length")

    ml = getDim(servo, "motorlength")
    sl = getDim(servo, "shoulderlength")
    ho = getDim(servo, "hornoffset")

    s = self.getParameter("shift")

    dy = l/2. - ml/2. - sl
    if self.getParameter("center"):
      dy = min(dy, ml/2. - ho)
    dy -= s
    if self.getParameter("flip"):
      dy = -dy

    self.setParameter("offset", (0, dy))

if __name__ == "__main__":
  ServoMount.test()

